import RPi.GPIO as GPIO
import time
import serial

portarray1 = [11,12,13,15,16,18,22,7]
portarray2 = [24,5,3,23,21,19,8,10]
keypressdata = [1,4,7,10,2,5,8,0,3,6,9,11]

#Setup Global GPIO
GPIO.setwarnings(False)
GPIO.setmode(GPIO.BOARD)

#Setup Keypad GPIO
GPIO.setup(portarray1[0], GPIO.OUT)
GPIO.setup(portarray1[1], GPIO.OUT)
GPIO.setup(portarray1[2], GPIO.OUT)
GPIO.setup(portarray1[4], GPIO.IN)
GPIO.setup(portarray1[5], GPIO.IN)
GPIO.setup(portarray1[6], GPIO.IN)
GPIO.setup(portarray1[7], GPIO.IN)

#Setup UART 9600 Baud, 1 second Timeout
ser = serial.Serial("/dev/ttyAMA0", 9600, timeout=1)

def ReadKeypad():
	retval = 255
	iCol = 0
	while iCol < 3:
		GPIO.output(portarray1[iCol], True)
		iRow = 0
		while iRow < 4:
			input = GPIO.input(portarray1[iRow + 4])
			if input:
				retval = keypressdata[(iCol * 4) + iRow]
				while input:
					input = GPIO.input(portarray1[iRow + 4])
				GPIO.output(portarray1[iCol], False)
				return retval
			iRow = iRow + 1
		GPIO.output(portarray1[iCol], False)
		iCol = iCol + 1
	return retval


def SendATCommand(command):
	print "out -> ", command
	ser.write(command)

	#Send Carriage Return
	ser.write("\r")

	#Recieve Echo
	ser.readline()

	#Collect Response
	line = ser.readline()
	print "In <- ", line


#Setup GSM
SendATCommand('AT+CMGF=1')
SendATCommand('AT+CNMI=1,2,0,0,0')
SendATCommand('AT#SLED=2')

#Main Program Loop
test = 255
while test != 11:
	test = ReadKeypad()
	if test < 255:	
		if test == 1:
			#Basic AT Command
			SendATCommand('AT')

		if test == 2:
			#Make a voice call
			SendATCommand('ATD07897701767;')

		if test == 3:
			#Hang up call
			SendATCommand('ATH')

#Keypad '#' key ends the program
ser.close()

