import RPi.GPIO as GPIO
import SocketServer

portarray1 = [11,12,13,15,16,18,22,7]
portarray2 = [24,5,3,23,21,19,8,10]

#alt portarray2 setup depending on jumper
#portarray2 = [24,26,3,23,21,19,8,10]

def portout (port, value, mask):
	idx = 0
	while idx < 8:
		tempmask = 0x01 << idx
		if (mask & tempmask == tempmask):
			if (port == 1):
				pin = portarray1[idx]
			if (port == 2):
				pin = portarray2[idx]
			GPIO.setup(pin, GPIO.OUT)
			if (value & tempmask == tempmask):
				GPIO.output(pin, True)
			else:
				GPIO.output(pin, False)
		idx = idx + 1
	return

def portin(port, mask):
	idx = 0
	retval = 0
	while idx < 8:
		tempmask = 0x01 << idx
		if (mask & tempmask == tempmask):
			if (port == 1):
				pin = portarray1[idx]
			if (port == 2):
				pin = portarray2[idx]
			GPIO.setup(pin, GPIO.IN)
			if (GPIO.input(pin)):
				retval = retval | (0x01 << idx)
		idx = idx + 1
	return retval


class EchoRequestHandler(SocketServer.BaseRequestHandler ):
	def setup(self):
		print self.client_address, 'connected!'
		self.request.send('hi ' + str(self.client_address) + '\n')

	def handle(self):
		data = 'dummy'
		while data:
			data = self.request.recv(1024)
			#self.request.send(data)
			
			strippeddata = data.strip()
			
			if strippeddata == 'bye':
				return
			if strippeddata == 'pt1_pn0_on':
				portout(1,0x01,0x01)
			if strippeddata == 'pt1_pn0_off':
				portout(1,0x00,0x01)
			if strippeddata == 'pt1_pn1_on':
				portout(1,0x02,0x02)
			if strippeddata == 'pt1_pn1_off':
				portout(1,0x00,0x02)
			if strippeddata == 'pt1_pn2_on':
				portout(1,0x04,0x04)
			if strippeddata == 'pt1_pn2_off':
				portout(1,0x00,0x04)
			if strippeddata == 'pt1_pn3_on':
				portout(1,0x08,0x08)
			if strippeddata == 'pt1_pn3_off':
				portout(1,0x00,0x08)

	def finish(self):
		print self.client_address, 'disconnected!'
		self.request.send('bye ' + str(self.client_address) + '\n')

	#server host is a tuple ('host', port)
server = SocketServer.ThreadingTCPServer(('', 1236), EchoRequestHandler)
server.serve_forever()
